# This pipeline is designed to be included from another repository, which includes this
# "tutorraform" repository as a submodule.

# We use that checked out submodule to dynamically generate and run a "child" GitLab CI pipeline
# https://docs.gitlab.com/ee/ci/parent_child_pipelines.html

# It's unfortunately not necessary to just "include" the main.yml file directly into the main .gitlab-ci.yml
# file, because "include" directives get parsed before submodules are checked out. But this is a cleaner separation
# anyways.

image: alpine:latest

generate pipeline:
  stage: build
  image: ruby:3-alpine
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  script:
    - tutorraform/gitlab-ci/generate-tutor-stage.rb
  artifacts:
    paths:
      - tutorraform/gitlab-ci/generated.yml

child pipeline:
  stage: deploy
  trigger:
    include:
      - artifact: tutorraform/gitlab-ci/generated.yml
        job: generate pipeline
    strategy: depend
